/* The horribly split up server parsing stuff
   so I can do hooks in here.  I know there's
   a better way to do this, but I want to get
   this all released, and then fix it up.
   - alex blarf@undernet */

#include "client.h"
#include "irc.h"
#include "hooks.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void Client::HandleCTCP_Reply(const char *sender,const char *data)
{
/* FIXME: Someone should take the time to split a CTCP into CTCP and rest */
  unsigned int count;

  Function_Hook exec_func;
  CTCP_Reply *param = new CTCP_Reply;
  QString out(1024),temp;

  param->nick.nick=QString(sender);
  param->nick.address=0;
  param->client=this;

  temp = QString(data);
  if ((temp.left(5)).lower() == "ping ") {
	temp.remove(0, 5);
	param->ctcp=QString("PING");
	param->rest=QString(temp);
	unsigned int oldTime = (unsigned int)(atoi(temp.data()));
	time_t currentTime = time(NULL);
	unsigned int pingTime = (unsigned int)currentTime - oldTime;
	out.sprintf("%s PING reply: %u seconds", sender, pingTime);
  } else {
	out.sprintf ("CTCP Notice from %s: %s", sender, data);
  }

  for (count=0;count<kircModules.Hooks.count();count++)
  {
	if (kircModules.Hooks.at(count)->hook_type == Hook::CTCPReply) {
	  exec_func=(Function_Hook)kircModules.Hooks.at(count)->func;
	  exec_func((void *)param);
	}
  }

  Output(Output::NOTICE, NULL, out);
  delete param;
}

void Client::Handle_Notice(const char *sender,const char *data)
{
  unsigned int count;
  Notice *param = new Notice;
  Function_Hook exec_func;

  param->client=this;
  param->chan=0;
  param->from.nick=QString(sender);
  param->from.address=0;
  param->message=QString(data);

  QString out(1024);
  out.sprintf ("CTCP Notice from %s: %s", sender, data);
  Output(Output::NOTICE, NULL, out);

  for (count=0;count<kircModules.Hooks.count();count++)
  {
	if (kircModules.Hooks.at(count)->hook_type == Hook::Notice) {
	  exec_func=(Function_Hook)kircModules.Hooks.at(count)->func;
	  exec_func((void *)param);
	}
  }

  delete param;
}

void Client::Handle_ServerPong(const char *data)
{
  unsigned int count;
  Pong *param = new Pong;
  Function_Hook exec_func;

  param->client=this;
  param->text=QString(data); /* FIXME */

  QString out(1024);
  out.sprintf("PONG %s\r\n", data);
  HandleEvent(Event::SOCKET_WRITE, out);

  for (count=0;count<kircModules.Hooks.count();count++)
  {
	if (kircModules.Hooks.at(count)->hook_type == Hook::Notice) {
	  exec_func=(Function_Hook)kircModules.Hooks.at(count)->func;
	  exec_func((void *)param);
	}
  }

  delete param;
}

void Client::Handle_Join(const char *nick,const char *address,const char *channel)
{
  unsigned int count;
  Join *param = new Join;
  Function_Hook exec_func;

  QString out(1024);
  if (QString(nick).lower() == Settings::myNick.lower())
	HandleEvent(Event::JOIN_CHANNEL, channel);
  out.sprintf("%s [%s] has joined the channel.", nick,address);
  Output(Output::NOTICE, channel, out);
  HandleEvent(Event::ADD_NICK, channel, nick);

  param->client=this;
  param->reason=0;
  param->nick.nick=QString(nick);
  param->nick.address=QString(address);
  param->chan=QString(channel);

  for (count=0;count<kircModules.Hooks.count();count++)
  {
	if (kircModules.Hooks.at(count)->hook_type == Hook::Join) {
	  exec_func=(Function_Hook)kircModules.Hooks.at(count)->func;
	  exec_func((void *)param);
	}
  }

  delete param;

}

void Client::Handle_Part(const char *nick,const char *address,const char *channel,const char *reason)
{
  unsigned int count;
  Part *param = new Part;
  Function_Hook exec_func;

  QString out(1024);

  if (QString(nick).lower() != Settings::myNick.lower()) {
	out.sprintf("%s [%s] has left the channel.", nick, address);
	Output(Output::NOTICE, channel, out);
	HandleEvent(Event::REMOVE_NICK, channel, nick);
  }

  param->client=this;
  param->reason=0;
  param->nick.nick=QString(nick);
  param->nick.address=QString(address);
  param->chan=QString(channel);

  for (count=0;count<kircModules.Hooks.count();count++)
  {
	if (kircModules.Hooks.at(count)->hook_type == Hook::Part) {
	  exec_func=(Function_Hook)kircModules.Hooks.at(count)->func;
	  exec_func((void *)param);
	}
  }
  delete param;
}

void Client::Handle_Kick(const char *victim, const char *kicker, const char *channel, const char *reason)
{
  unsigned int count;
  Kick *param = new Kick;
  Function_Hook exec_func;

  QString out(1024);
  if (QString(victim).lower() != Settings::myNick.lower()) {
	out.sprintf("%s was kicked by %s (%s)", victim, kicker, reason);
	Output(Output::NOTICE, channel, out);
	HandleEvent(Event::REMOVE_NICK, channel, victim);
  } else {
	out.sprintf("You were kicked off channel %s by %s (%s).  Attempting to rejoin...",channel,kicker,reason);
	Output(Output::ERROR, channel, out);
	out.sprintf("JOIN %s\r\n", channel);
	HandleEvent(Event::SOCKET_WRITE, out);
  }

  param->client=this;
  param->chan=QString(channel);
  param->reason=QString(reason);
  param->kicked=QString(victim);

  for (count=0;count<kircModules.Hooks.count();count++)
  {
	if (kircModules.Hooks.at(count)->hook_type == Hook::Kick) {
	  exec_func=(Function_Hook)kircModules.Hooks.at(count)->func;
	  exec_func((void *)param);
	}
  }
  delete param;
}

void Client::Handle_Nick(const char *from, const char *to)
{
  if (QString(from).lower() == Settings::myNick.lower())
	HandleEvent(Event::CHANGE_MY_NICK, to);
  else
	HandleEvent(Event::CHANGE_NICK, from, to);
  return;
}

void Client::Handle_Quit(const char *nick, const char *reason)
{
  unsigned int count;
  Quit *param = new Quit;
  Function_Hook exec_func;

  param->client=this;
  param->chan=0;
  param->reason=QString(reason);
  param->nick.nick=QString(nick);

  for (count=0;count<kircModules.Hooks.count();count++)
  {
	if (kircModules.Hooks.at(count)->hook_type == Hook::Quit) {
	  exec_func=(Function_Hook)kircModules.Hooks.at(count)->func;
	  exec_func((void *)param);
	}
  }

  HandleEvent(Event::SIGNOFF, nick, reason);
  delete param;
}
