#ifndef HOOKS_H
#define HOOKS_H

#include "client.h"

class HookBase
{
public:
	Client *client;
};

class Nick
{
public:
	QString nick,address;
};

class CTCP_Reply :
	public HookBase
{
public:
	QString ctcp,rest;
	Nick nick;
};

class Action :
	public HookBase
{
public:
	QString chan,action;
	Nick nick;
};

class Msg :
	public HookBase
{
public:
	QString chan,message;
	Nick from;
};

class Part :
	public HookBase
{
public:
	QString chan,reason;
	Nick nick;
};

class Kick :
	public HookBase
{
public:
	Nick kicker;
	QString kicked,chan,reason;
};

class Pong :
	public HookBase
{
public:
	QString server,text;
};

typedef Part Join; /* There is no reason */
typedef Part Quit; /* There is no channel */
typedef Msg Notice; /* If it's not to a channel chan==0 */

#endif
