/* $Id$
   kirc Module handling file, by Alex Zepeda <garbanzo@hooked.net>
   */

#ifndef MODULES_H
#define MODULES_H

#include <qlist.h>
#include <qstring.h>

class moduleEnt {
public:
  moduleEnt(const char *);
  ~moduleEnt(){};
  int id;
  QString name;
  QString path;
  void *handle;
};

class Hook {
public:
  Hook(){};
  ~Hook(){};
  enum Hook_Types {Action,CTCPReply,DCC,Describe,Join,Kick,Notice,Numeric,Part,
	Pong,PrivMsg,PubMsg,Quit,Raw,Wallops};
  int hook_type, owner, numeric;
  void *func;
  QString trigger_text, sender;
  QList<QString> channels;

};

class modLoader {
public:
  modLoader();
  ~modLoader(){};
  bool load_module(const char *);
  bool unload_module(int);
  bool unload_module(const char *);
  void * find_symbol(int, const char *);
  void add_hook(Hook *);
  QList<Hook> Hooks;
protected:
  QList<moduleEnt> modules;
};

typedef int (*Function)();
typedef void (*Function_Exec)(int,void *,void *);
typedef int (*Function_Hook)(void *);

#endif









